#! /s/std/bin/perl

$top = "/local.ostrich/johnbent";
$data_dir = "$top/DATA";
$DB_DIR = "$top/DB";

@bad_users = qw( sanjeevk ballard condor pfc bforney ong psilord wright thain );

$user;
$file;
$ip;
$job;


chdir( $data_dir );
foreach $file (<*>) {
	get_meta_file_info( $file );
	$users{$user}++;
}

while( ($user, $jobs) = each(%users) ) {
	#print "$user has $jobs jobs.\n";
	push @reversed, "$jobs:$user"; 
} 

@sorted = reverse sort compare @reversed;

USER: for ($i = 0; $i < @sorted; $i++) {
    ($jobs, $user) = split(/:/, $sorted[$i]);
	next USER if ( isBadUser( $user ) );
	$total_users++;
	$total_jobs += $jobs;
	write( STDOUT );
}

print "TOTAL:\n";
$jobs = $total_jobs;
$user = "$total_users users";
write( STDOUT );

exit 0;

# subroutines end here.

sub
isBadUser {
	foreach $baduser (@bad_users) {
		return 1 if ($_[0] eq $baduser);
	}
	
	return 0;
}

format STDOUT = 
@<<<<<<<<<< has ^>>>> jobs.
$user				 $jobs
.

sub 
compare { $a <=> $b; }


sub
get_meta_file_info {
	($front, $back) = split (/cluster/, $_[0]);
	($cluster, $proc) = split (/\./, $back);
	$proc =~ s/[a-z]*//;
	($one, $two, $three, $four) = split (/\./, $front);
	$user = $four;
	$user =~ s/[0-9]*//;
	$four =~ s/[a-zA-Z]*$//;
	$ip = "$one.$two.$three.$four";
	$job = "$cluster.$proc";	
}
