#! /s/std/bin/perl

$pretty_print = 0;

die "Usage: $0 filename [pretty_print].\n" unless $ARGV[0];
die "Usage: $0 filename [pretty_print].\n" unless( -e $ARGV[0] );

$pretty_print = $ARGV[1];

open INPUT, $ARGV[0];

while (<INPUT>) {

	next if (/allocSize/);

	if (/percent/) {
		$random = ((/random/) ? 1 : 0);

		($percent) = split;
		
		for ($i = 0; $i < 2; $i++) {
			$_ = <INPUT>;
			($wall, $usr, $sys, $num, $incremental, $pages, $writes) 
				= split(/:/);
			$bucket = $percent / 10;
			$wall /= 1000; # convert from micros to millis
			
			if ($incremental) {
				if ($random) {
					$inc_rand_pages[$bucket]  += $pages;
					$inc_rand_writes[$bucket] += $writes;
					$inc_rand_clock[$bucket]  += $wall;
					$inc_rand_sys[$bucket] += $sys;
					$inc_rand_usr[$bucket] += $usr;
					$inc_rand_count[$bucket]++;
				} else {
					$inc_clus_pages[$bucket]  += $pages;
					$inc_clus_writes[$bucket] += $writes;
					$inc_clus_clock[$bucket]  += $wall;
					$inc_clus_sys[$bucket] += $sys;
					$inc_clus_usr[$bucket] += $usr;
					$inc_clus_count[$bucket]++;
				}
			} else {
				if ($random) {
					$seq_rand_pages[$bucket]  += $pages;
					$seq_rand_clock[$bucket]  += $wall;
					$seq_rand_sys[$bucket] += $sys;
					$seq_rand_usr[$bucket] += $usr;
					$seq_rand_count[$bucket]++;
				} else {
					$seq_clus_pages[$bucket]  += $pages;
					$seq_clus_clock[$bucket]  += $wall;
					$seq_clus_sys[$bucket] += $sys;
					$seq_clus_usr[$bucket] += $usr;
					$seq_clus_count[$bucket]++;
				}
			}	
		}

	}
}

print "Averages values from approx. $seq_clus_count[0] runs.\n"
        if $pretty_print;

open OUTPUT, "Seq_Rand";

print "sequential randomized locality\n" if $pretty_print;
$type = "seq_rand";
for ($i = 0; $i <= 10; $i++) {
	next unless ($seq_rand_count[$i]);

	$percent = $i * 10;
	$writes = 1;
	$cnt = $seq_rand_count[$i];
	$clock = $seq_rand_clock[$i] / $cnt; 
	$pages = $seq_rand_pages[$i] / $cnt; 
	$sys = $seq_rand_sys[$i] / $cnt; 
	$usr = $seq_rand_usr[$i] / $cnt; 
        if ($pretty_print) { write STDOUT; }
        else { print OUTPUT "$percent\t$clock\n"; }
} 

close OUTPUT;
open OUTPUT, "Seq_Clus";

print "sequential clustered locality\n" if $pretty_print;
$type = "seq_clus";
for ($i = 0; $i <= 10; $i++) {
	next unless ($seq_clus_count[$i]);

	$percent = $i * 10;
	$writes = 1;
	$cnt = $seq_clus_count[$i];
	$clock = $seq_clus_clock[$i] / $cnt; 
	$pages = $seq_clus_pages[$i] / $cnt;
	$sys = $seq_clus_sys[$i] / $cnt; 
	$usr = $seq_clus_usr[$i] / $cnt; 
        if ($pretty_print) { write STDOUT; }
        else { print OUTPUT "$percent\t$clock\n"; }
} 

close OUTPUT;
open OUTPUT, "Inc_Rand";

print "incremental randomized locality\n" if $pretty_print;
$type = "inc_rand";
for ($i = 0; $i <= 10; $i++) {
	next unless ($inc_rand_count[$i]);

	$percent = $i * 10;
	$cnt = $inc_rand_count[$i];
	$writes = $inc_rand_writes[$i] / $cnt; 
	$clock = $inc_rand_clock[$i] / $cnt; 
	$pages = $inc_rand_pages[$i] / $cnt; 
	$sys = $inc_rand_sys[$i] / $cnt; 
	$usr = $inc_rand_usr[$i] / $cnt; 
        if ($pretty_print) { write STDOUT; }
        else { print OUTPUT "$percent\t$clock\n"; }
} 

close OUTPUT;
open OUTPUT, "Inc_Clus";

print "incremental clustered locality\n" if $pretty_print;
$type = "inc_clus";
for ($i = 0; $i <= 10; $i++) {
	next unless ($inc_clus_count[$i]);

	$percent = $i * 10;
	$cnt = $inc_clus_count[$i];
	$writes = $inc_clus_writes[$i] / $cnt;
	$clock = $inc_clus_clock[$i] / $cnt;
	$pages = $inc_clus_pages[$i] / $cnt;
	$sys = $inc_clus_sys[$i] / $cnt; 
	$usr = $inc_clus_usr[$i] / $cnt; 
        if ($pretty_print) { write STDOUT; }
        else { print OUTPUT "$percent\t$clock\n"; }
} 

format STDOUT = 
@>>> %:  @>>>>>> ms,  @<<<:@<<< s:u,  @>>>> w,  @>>>>> p
$percent $clock $sys $usr $writes $pages
.
